/* Patch Timidity++ 2.7.0 (and probably above) for OS/2.
   NOTE: You must run it only once on a just uncompressed source !
   */

dart_a="timidity\dart_a.c"
slang_h="interface\slang.h"
configure="configure"
output_c="timidity\output.c"
output_h="timidity\output.h"

say '*** PatchOS/2: Checking the distributive'
if stream(dart_a,'c','query exists')='' then do
   say 'You should copy' dart_a 'from the OS/2 version distribution.'
   exit(1)
   end
if stream(slang_h,'c','query exists')='' then do
   say 'You should copy' slang_h 'from the OS/2 version distribution.'
   exit(1)
   end
say '*** PatchOS/2: Patching' configure

if (stream(configure,'c','query exists')='') then do
   say 'File not found:' configure
   exit(1)
   end
Temp=configure'~'
'@if exist' Temp 'del' Temp
Step=0
do while chars(configure)<>0
   Next=linein(configure)
   select
      when Step=0 then
         if pos('checking whether the C compiler',Next)<>0 then Step=1
      when Step=1 then 
         if Next='ac_ext=c' then do
            call lineout Temp,Next
            Next='ac_exeext=.exe'
            Step=2
            end
      when Step=2 then
         if pos('if test -n "$RANLIB"; then',Next)<>0 then Step=3
      when Step=3 then do
         p=pos('if test -f $ac_dir/$ac_word; then',Next)
         if p<>0 then do
            Next="    if test -f $ac_dir/$ac_word$ac_exeext; then"
            Step=4
            end
         end
      otherwise nop
      end
   call lineout Temp,Next
   end
call stream configure,'c','close'
call stream Temp,'c','close'
if Step<>4 then do
   say 'Inconsistent contents in' configure
   exit(1)
   end
'@copy' Temp configure'>nul'
'@del' Temp


say '*** PatchOS/2: Patching' output_c

if (stream(output_c,'c','query exists')='') then do
   say 'File not found:' output_c
   exit(1)
   end
Temp=output_c'~'
'@if exist' Temp 'del' Temp
Step=0
do while chars(output_c)<>0
   Next=linein(output_c)
   select
      when Step=0 then
         if pos('#elif defined(AU_BSDI)',Next)<>0 then Step=1
      when Step=1 then 
         if pos('#define DEV_PLAY_MODE',Next)<>0 then do
            call lineout Temp,Next
            call lineout Temp,""
            call lineout Temp,"#elif defined(AU_DART)"
            call lineout Temp,"extern PlayMode dart_play_mode;"
            Next="#define DEV_PLAY_MODE &dart_play_mode"
            Step=2
            end
      otherwise nop
      end
   call lineout Temp,Next
   end
call stream output_c,'c','close'
call stream Temp,'c','close'
if Step<>2 then do
   say 'Inconsistent contents in' output_c
   exit(1)
   end
'@copy' Temp output_c'>nul'
'@del' Temp

say '*** PatchOS/2: Patching' output_h

if (stream(output_h,'c','query exists')='') then do
   say 'File not found:' output_h
   exit(1)
   end
Temp=output_h'~'
'@if exist' Temp 'del' Temp
do while chars(output_h)<>0
   Next=linein(output_h)
   if pos('#define FILE_OUTPUT_MODE	O_WRONLY|O_CREAT|O_TRUNC|O_BINARY, 0644',Next)<>0 then do
      call lineout Temp,Next
      call lineout Temp,"#elif defined(__EMX__)"
      end
   call lineout Temp,Next
   end
call stream output_h,'c','close'
call stream Temp,'c','close'
'@copy' Temp output_h'>nul'
'@del' Temp

say '*** PatchOS/2: Complete'
